/**
 * This is the main cog_test program file.
 */
#include <stdio.h>
#include <unistd.h>
#include <propeller.h>
#include "cog_test.h"
#include "simpletools.h"                      // Include simpletools library 

/* control block for cogA */
struct {
    unsigned stack[STACK_SIZE_A];
    volatile struct cogA_mailbox A;
} parA;

/* control block for cogB */
struct {
    unsigned stack[STACK_SIZE_B];
    volatile struct cogB_mailbox B;
} parB;

/* start cogA */
void startA(volatile void *parptr)
{
    extern unsigned int _load_start_cogA_cog[];
#if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC__)
    load_cog_driver_xmm(_load_start_cogA_cog, 496, (uint32_t *)parptr);
#else
    cognew(_load_start_cogA_cog, parptr);
#endif
}

/* start cogB */
void startB(volatile void *parptr)
{
    extern unsigned int _load_start_cogB_cog[];
#if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC__)
    load_cog_driver_xmm(_load_start_cogB_cog, 496, (uint32_t *)parptr);
#else
    cognew(_load_start_cogB_cog, parptr);
#endif
}

int main(void)
{
    sleep(2);  
/* start the A cog */
    printf("starting cogA\n");
    startA(&parA.A);
    printf("%s\n",parA.A.cog_message);

/* start the B cog */
    printf("starting cogB\n");
    startB(&parB.B);
    printf("%s\n",parB.B.cog_message);

/* loop forever */
    while(1) {
        sleep(2);
        printf("cogA: %s\n",parA.A.cog_message);
        printf("cogB: %s\n",parB.B.cog_message);
    }
    return 0;
}